-- name: Hotel Mario
-- description: You know what they say, where there's smoke, they pinch back.\n\nBy \\#d6c899\\eros\\#6fb900\\71\\#ffffff\\.

-- Fair warning for anybody looking at this, specially you X
-- This is code is ugly and very unoptimized, this was made as a joke and I don't have any plans to improve it. -- lol

-- No, seriously this code is fugly, from this line below, you're on your own. Good luck.

local firstRan = false
local playVideo = false
local videoIsFinished = false
local speedLimit = 1

local loadTimer = 1 * 30 -- 1 seconds times 30 frames per second
-- This timer didn't exist originally, but after shrinking down the frames, the game loads them faster than the audio and it desyncs, this prevents that

local frameTimer = 0
local frameCounter = 0

local width = 0
local height = 0

-- Every frame texture is stored as "intro_xxxxx" where xxxxx is the frame number
local frameToPlay = get_texture_info("intro_00001")

-- Audio
local audio = audio_stream_load("hotel_mario_intro.mp3")

function on_level_init()
    if videoIsFinished then return end
    if not firstRan or videoIsFinished then
        firstRan = true
        playVideo = true
        audio_stream_set_looping(audio, false)
        audio_stream_play(audio, false, 1)
    end
end

function on_hud_render()
    if videoIsFinished then return end
    if playVideo then
        width = djui_hud_get_screen_width()
        height = djui_hud_get_screen_height()
        djui_hud_set_resolution(RESOLUTION_DJUI)
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_render_rect(0, 0, width, height)
        djui_hud_reset_color()
        djui_hud_set_resolution(RESOLUTION_N64)
        width = djui_hud_get_screen_width()
        --djui_hud_render_texture(frameToPlay, (width/2.75)-frameToPlay.height/4, -75, 0.75, 0.75)
        -- And now we cycle through the frames, there's 1506 of them
        if frameCounter >= 1506 then
            videoIsFinished = true
            playVideo = false
            sound_banks_enable(SEQ_PLAYER_SFX, SOUND_BANKS_ALL)
        end
        djui_hud_render_texture(frameToPlay, (width / 2) - frameToPlay.width * 1.5, -75, 3, 3)
    end
end

-- This function is called 30 times per second, we will need it to make sure the video isn't playing too fast
function on_update()
    if videoIsFinished then return end
    if loadTimer > 0 then
        loadTimer = loadTimer - 1
        return
    end
    -- If the video is playing, we need to make sure it's not playing too fast
    frameTimer = frameTimer + 1
    if frameTimer >= speedLimit then
        frameTimer = 0
        frameCounter = frameCounter + 1
    end
    if frameCounter < 1506 then
        if frameTimer == 0 then
            frameToPlay = get_texture_info("intro_" .. string.format("%05d", frameCounter))
        end
    end
end

---@param m MarioState
function mario_update_local(m)
    if m.playerIndex ~= 0 or videoIsFinished then return end
    m.controller.buttonPressed = m.controller.buttonPressed & ~A_BUTTON
    m.controller.buttonPressed = m.controller.buttonPressed & ~B_BUTTON
    m.controller.buttonPressed = m.controller.buttonPressed & ~L_TRIG
    m.controller.buttonPressed = m.controller.buttonPressed & ~R_TRIG
    m.controller.buttonPressed = m.controller.buttonPressed & ~X_BUTTON
    m.controller.buttonPressed = m.controller.buttonPressed & ~Y_BUTTON
    m.controller.buttonPressed = m.controller.buttonPressed & ~Z_TRIG
    m.controller.stickMag = 0
    m.controller.stickX = 0
    m.controller.stickY = 0
    sound_banks_disable(SEQ_PLAYER_SFX, SOUND_BANKS_ALL)
end

hook_event(HOOK_ON_LEVEL_INIT, on_level_init)
hook_event(HOOK_ON_HUD_RENDER, on_hud_render)
hook_event(HOOK_UPDATE, on_update)
hook_event(HOOK_MARIO_UPDATE, mario_update_local)
